from enum import Enum
from plum import dispatch
from typing import TypeVar, Union, Generic, List, Tuple
from spire.pdf.common import *
from spire.pdf import *
from ctypes import *
import abc

class PdfCheckFieldBase(PdfStyledField):
    """
    Represents base class for field which can be in checked and unchecked states.
    """

    @property
    def Style(self) -> 'PdfCheckBoxStyle':
        """
        Gets or sets the style.

        Returns:
            The PdfCheckBoxStyle object specifies the style of the check box field.
        """
        GetDllLibPdf().PdfCheckFieldBase_get_Style.argtypes = [c_void_p]
        GetDllLibPdf().PdfCheckFieldBase_get_Style.restype = c_int
        ret = CallCFunction(GetDllLibPdf().PdfCheckFieldBase_get_Style,self.Ptr)
        objwrapped = PdfCheckBoxStyle(ret)
        return objwrapped

    @Style.setter
    def Style(self, value: 'PdfCheckBoxStyle'):
        """
        Sets the style.

        Args:
            value: The PdfCheckBoxStyle object specifies the style of the check box field.
        """
        GetDllLibPdf().PdfCheckFieldBase_set_Style.argtypes = [c_void_p, c_int]
        CallCFunction(GetDllLibPdf().PdfCheckFieldBase_set_Style,self.Ptr, value.value)