from enum import Enum
from plum import dispatch
from typing import TypeVar, Union, Generic, List, Tuple
from spire.pdf.common import *
from spire.pdf import *
from ctypes import *
import abc

class PdfCodabarBarcode(PdfUnidimensionalBarcode):
    @dispatch
    def __init__(self):
        """
        Initializes a new instance of the PdfCodabarBarcode class.
        """
        GetDllLibPdf().PdfCodabarBarcode_CreatePdfCodabarBarcode.restype = c_void_p
        intPtr = CallCFunction(GetDllLibPdf().PdfCodabarBarcode_CreatePdfCodabarBarcode)
        super(PdfCodabarBarcode, self).__init__(intPtr)
    
    @dispatch
    def __init__(self, text: str):
        """
        Initializes a new instance of the PdfCodabarBarcode class with the specified text.
        
        Args:
            text (str): The text to be encoded in the barcode.
        """
        GetDllLibPdf().PdfCodabarBarcode_CreatePdfCodabarBarcodeT.argtypes = [c_wchar_p]
        GetDllLibPdf().PdfCodabarBarcode_CreatePdfCodabarBarcodeT.restype = c_void_p
        intPtr = CallCFunction(GetDllLibPdf().PdfCodabarBarcode_CreatePdfCodabarBarcodeT,text)
        super(PdfCodabarBarcode, self).__init__(intPtr)
    
    """
    Represents a Codabar barcode.
    
    This symbology allows the encoding of strings of up to 16 digits, 10 numeric digits (0 through 9) and 
    6 special non alpha characters ("+", "-", "$", "/", ":", "."). 
    """
    pass