from enum import Enum
from plum import dispatch
from typing import TypeVar, Union, Generic, List, Tuple
from spire.pdf.common import *
from spire.pdf import *
from ctypes import *
import abc

class PdfComplexColor(SpireObject):
    """
    Represents the extended color, based on a complex colorspace.
    """

    @property
    def ColorSpace(self) -> 'PdfColorSpaces':
        """
        Gets the Colorspace.
        """
        GetDllLibPdf().PdfComplexColor_get_ColorSpace.argtypes = [c_void_p]
        GetDllLibPdf().PdfComplexColor_get_ColorSpace.restype = c_void_p
        intPtr = CallCFunction(GetDllLibPdf().PdfComplexColor_get_ColorSpace,self.Ptr)
        ret = None if intPtr == None else PdfColorSpaces(intPtr)
        return ret