from enum import Enum
from plum import dispatch
from typing import TypeVar, Union, Generic, List, Tuple
from spire.pdf.common import *
from spire.pdf import *
from ctypes import *
import abc

class PdfDeviceColorSpace(PdfColorSpaces):
    """
    Represents a device colorspace.
    """

    @property
    def DeviceColorSpaceType(self) -> 'PdfColorSpace':
        """
        Gets or sets the DeviceColorSpaceType.
        """
        GetDllLibPdf().PdfDeviceColorSpace_get_DeviceColorSpaceType.argtypes = [c_void_p]
        GetDllLibPdf().PdfDeviceColorSpace_get_DeviceColorSpaceType.restype = c_int
        ret = CallCFunction(GetDllLibPdf().PdfDeviceColorSpace_get_DeviceColorSpaceType,self.Ptr)
        objwrapped = PdfColorSpace(ret)
        return objwrapped

    @DeviceColorSpaceType.setter
    def DeviceColorSpaceType(self, value: 'PdfColorSpace'):
        """
        Sets the DeviceColorSpaceType.
        """
        GetDllLibPdf().PdfDeviceColorSpace_set_DeviceColorSpaceType.argtypes = [c_void_p, c_int]
        CallCFunction(GetDllLibPdf().PdfDeviceColorSpace_set_DeviceColorSpaceType,self.Ptr, value.value)