from enum import Enum
from plum import dispatch
from typing import TypeVar, Union, Generic, List, Tuple
from spire.pdf.common import *
from spire.pdf import *
from ctypes import *
import abc

class PdfFieldWidgetImportError(SpireObject):
    """
    Represents an error that occurs when importing a PDF field widget.
    """

    @property
    def FieldWidget(self) -> 'PdfFieldWidget':
        """
        Gets the PDF field widget associated with the import error.
        """
        GetDllLibPdf().PdfFieldWidgetImportError_get_FieldWidget.argtypes = [c_void_p]
        GetDllLibPdf().PdfFieldWidgetImportError_get_FieldWidget.restype = c_void_p
        intPtr = CallCFunction(GetDllLibPdf().PdfFieldWidgetImportError_get_FieldWidget,self.Ptr)
        ret = None if intPtr == None else PdfFieldWidget(intPtr)
        return ret