from enum import Enum
from plum import dispatch
from typing import TypeVar, Union, Generic, List, Tuple
from spire.pdf.common import *
from spire.pdf import *
from ctypes import *
import abc

class PdfInkAnnotation(PdfAnnotation):
    """
    Represents Ink annotation in the PDF.
    """

    @property
    def Opacity(self) -> float:
        """
        Gets or sets the annotation opacity. 
        The opacity is given in decimal, 1 is full opacity, 0 is no opacity.
        """
        GetDllLibPdf().PdfInkAnnotation_get_Opacity.argtypes = [c_void_p]
        GetDllLibPdf().PdfInkAnnotation_get_Opacity.restype = c_float
        ret = CallCFunction(GetDllLibPdf().PdfInkAnnotation_get_Opacity,self.Ptr)
        return ret

    @Opacity.setter
    def Opacity(self, value: float):
        GetDllLibPdf().PdfInkAnnotation_set_Opacity.argtypes = [c_void_p, c_float]
        CallCFunction(GetDllLibPdf().PdfInkAnnotation_set_Opacity,self.Ptr, value)