from enum import Enum
from plum import dispatch
from typing import TypeVar, Union, Generic, List, Tuple
from spire.pdf.common import *
from spire.pdf import *
from ctypes import *
import abc

class PdfLayoutHTMLResult(PdfLayoutResult):
    """
    Represents the result of a PDF layout with HTML content.
    """

    @property
    def HTMLViewBounds(self) -> 'RectangleF':
        """
        Gets the actual bounds of the HTML view. It may be larger than the overall bounds.
        """
        GetDllLibPdf().PdfLayoutHTMLResult_get_HTMLViewBounds.argtypes = [c_void_p]
        GetDllLibPdf().PdfLayoutHTMLResult_get_HTMLViewBounds.restype = c_void_p
        intPtr = CallCFunction(GetDllLibPdf().PdfLayoutHTMLResult_get_HTMLViewBounds,self.Ptr)
        ret = None if intPtr == None else RectangleF(intPtr)
        return ret