from enum import Enum
from plum import dispatch
from typing import TypeVar, Union, Generic, List, Tuple
from spire.pdf.common import *
from spire.pdf import *
from ctypes import *
import abc

class PdfPKCS1Formatter(IPdfSignatureFormatter, Security_IPdfSignatureFormatter):
    """
    Pdf pkcs1 signature implementation.
    """

    @property
    def Properties(self) -> 'PdfSignatureProperties':
        """
        The signature properties.
        """
        GetDllLibPdf().PdfPKCS1Formatter_get_Properties.argtypes = [c_void_p]
        GetDllLibPdf().PdfPKCS1Formatter_get_Properties.restype = c_void_p
        intPtr = CallCFunction(GetDllLibPdf().PdfPKCS1Formatter_get_Properties,self.Ptr)
        ret = None if intPtr == None else PdfSignatureProperties(intPtr)
        return ret


#    @property
#
#    def Parameters(self)->'Dictionary2':
#        """
#    Parameters for the encoding of the signature.
#    """
#        GetDllLibPdf().PdfPKCS1Formatter_get_Parameters.argtypes=[c_void_p]
#        GetDllLibPdf().PdfPKCS1Formatter_get_Parameters.restype=c_void_p
#        intPtr = CallCFunction(GetDllLibPdf().PdfPKCS1Formatter_get_Parameters,self.Ptr)
#        ret = None if intPtr==None else Dictionary2(intPtr)
#        return ret
#


#
#    def Sign(self ,content:'Byte[]')->List['Byte']:
#        """
#    Sign.
#    :param content: The data to be signed.
#    :returns: The signature.
#        """
#        #arraycontent:ArrayTypecontent = ""
#        countcontent = len(content)
#        ArrayTypecontent = c_void_p * countcontent
#        arraycontent = ArrayTypecontent()
#        for i in range(0, countcontent):
#            arraycontent[i] = content[i].Ptr
#
#
#        GetDllLibPdf().PdfPKCS1Formatter_Sign.argtypes=[c_void_p ,ArrayTypecontent]
#        GetDllLibPdf().PdfPKCS1Formatter_Sign.restype=IntPtrArray
#        intPtrArray = CallCFunction(GetDllLibPdf().PdfPKCS1Formatter_Sign,self.Ptr, arraycontent)
#        ret = GetObjVectorFromArray(intPtrArray, Byte)
#        return ret