from enum import Enum
from plum import dispatch
from typing import TypeVar, Union, Generic, List, Tuple
from spire.pdf.common import *
from spire.pdf import *
from ctypes import *
import abc

class PdfTableLayoutFormat(PdfTextLayout):
    """
    Represents the parameters for Light Table layout.
    """

    @property
    def StartColumnIndex(self) -> int:
        """
        Gets or sets the start column index.
        """
        GetDllLibPdf().PdfTableLayoutFormat_get_StartColumnIndex.argtypes = [c_void_p]
        GetDllLibPdf().PdfTableLayoutFormat_get_StartColumnIndex.restype = c_int
        ret = CallCFunction(GetDllLibPdf().PdfTableLayoutFormat_get_StartColumnIndex,self.Ptr)
        return ret

    @StartColumnIndex.setter
    def StartColumnIndex(self, value: int):
        GetDllLibPdf().PdfTableLayoutFormat_set_StartColumnIndex.argtypes = [c_void_p, c_int]
        CallCFunction(GetDllLibPdf().PdfTableLayoutFormat_set_StartColumnIndex,self.Ptr, value)

    @property
    def EndColumnIndex(self) -> int:
        """
        Gets or sets the end column index.
        """
        GetDllLibPdf().PdfTableLayoutFormat_get_EndColumnIndex.argtypes = [c_void_p]
        GetDllLibPdf().PdfTableLayoutFormat_get_EndColumnIndex.restype = c_int
        ret = CallCFunction(GetDllLibPdf().PdfTableLayoutFormat_get_EndColumnIndex,self.Ptr)
        return ret

    @EndColumnIndex.setter
    def EndColumnIndex(self, value: int):
        GetDllLibPdf().PdfTableLayoutFormat_set_EndColumnIndex.argtypes = [c_void_p, c_int]
        CallCFunction(GetDllLibPdf().PdfTableLayoutFormat_set_EndColumnIndex,self.Ptr, value)